;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: cl-user -*-

(in-package cl-user)

#+:mcl
(eval-when (:compile-toplevel :load-toplevel :execute)
  (require :opentransport))

#+:lispworks
(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "comm"))

(defpackage racer
  (:use common-lisp :nrql-symbols #+:allegro :excl)

  (:export #:*bottom*
	   #:*top*
	   #:+
	   #:-
	   #:<
	   #:<=
	   #:<>
	   #:=
	   #:>
	   #:>=
	   #:a
	   #:abox-consistent-if-assertions-added-p
	   #:abox-consistent-p
	   #:abox-consistent?
	   #:abox-prepared-p
	   #:abox-prepared?
	   #:abox-realized-p
	   #:abox-realized?
	   #:abox-una-consistent-p
	   #:abox-una-consistent?
	   #:add-all-different-assertion
	   #:add-annotation-concept-assertion
	   #:add-annotation-role-assertion
	   #:add-attribute-assertion
	   #:add-concept-assertion
	   #:add-concept-axiom
	   #:add-constraint-assertion
	   #:add-datatype-property
	   #:add-datatype-role-filler
	   #:add-different-from-assertion
	   #:add-disjointness-axiom
	   #:add-event-assertion
	   #:add-event-rule
	   #:add-individual
	   #:add-negated-role-assertion
	   #:add-negative-datatype-role-filler
	   #:add-prefix
	   #:add-role-assertion
	   #:add-role-axioms
	   #:add-rule-axiom
	   #:add-same-individual-as-assertion
	   #:alc-concept-coherent
	   #:all
	   #:all-aboxes
	   #:all-annotation-concept-assertions
	   #:all-annotation-role-assertions
	   #:all-atomic-concepts
	   #:all-attribute-assertions
	   #:all-attributes
	   #:all-concept-assertions
	   #:all-concept-assertions-for-individual
	   #:all-constraints
	   #:all-different
	   #:all-equivalent-concepts
	   #:all-features
	   #:all-individuals
	   #:all-role-assertions
	   #:all-role-assertions-for-individual-in-domain
	   #:all-role-assertions-for-individual-in-range
	   #:all-roles
	   #:all-tboxes
	   #:all-transitive-roles
	   #:an
	   #:and
	   #:associated-aboxes
	   #:associated-tbox
	   #:asymmetric
	   #:asymmetric-p
	   #:asymmetric?
	   #:at-least
	   #:at-most
	   #:atomic-concept-ancestors
	   #:atomic-concept-children
	   #:atomic-concept-descendants
	   #:atomic-concept-parents
	   #:atomic-concept-synonyms
	   #:atomic-role-ancestors
	   #:atomic-role-antonyms
	   #:atomic-role-children
	   #:atomic-role-descendants
	   #:atomic-role-domain
	   #:atomic-role-inverse
	   #:atomic-role-parents
	   #:atomic-role-range
	   #:atomic-role-synonyms
	   #:attribute-domain
	   #:attribute-domain-1
	   #:attribute-filler
	   #:attribute-has-domain
	   #:attribute-has-range
	   #:attribute-type
	   #:beta-version-p
	   #:boolean
	   #:boolean<>
	   #:boolean=
	   #:bottom
	   #:cardinal
	   #:cd-attribute-p
	   #:cd-attribute?
	   #:cd-object-p
	   #:cd-object?
	   #:check-abox-coherence
	   #:check-subscriptions
	   #:check-tbox-coherence
	   #:classify-tbox
	   #:clear-default-tbox
	   #:clear-mirror-table
	   #:clone-abox
	   #:clone-tbox
	   #:close-triple-store
	   #:complex
	   #:compute-all-implicit-role-fillers
	   #:compute-implicit-role-fillers
	   #:compute-index-for-instance-retrieval
	   #:concept-ancestors
	   #:concept-children
	   #:concept-descendants
	   #:concept-disjoint-p
	   #:concept-disjoint?
	   #:concept-equivalent-p
	   #:concept-equivalent?
	   #:concept-instances
	   #:concept-is-primitive-p
	   #:concept-is-primitive?
	   #:concept-offspring
	   #:concept-p
	   #:concept-parents
	   #:concept-satisfiable-p
	   #:concept-satisfiable?
	   #:concept-subsumes-p
	   #:concept-subsumes?
	   #:concept-synonyms
	   #:concept?
	   #:constrained
	   #:constraint-entailed-p
	   #:constraint-entailed?
	   #:constraints
	   #:convert-event-specs
	   #:create-abox-clone
	   #:create-tbox-clone
	   #:create-tbox-internal-marker-concept
	   #:create-triple-store
	   #:current-abox
	   #:current-tbox
	   #:d-all
	   #:d-at-least
	   #:d-at-most
	   #:d-base-type
	   #:d-complement
	   #:d-datarange
	   #:d-facet
	   #:d-filler
	   #:d-literal
	   #:d-possible-values
	   #:d-some
	   #:datarange
	   #:datatype-role-filler
	   #:datatype-role-has-range
	   #:datatype-role-range
	   #:declare-current-knowledge-bases-as-persistent
	   #:declare-disjoint
	   #:declare-role-axiom
	   #:default
	   #:defcdattribute
	   #:defconcept
	   #:define-abox
	   #:define-abox-1
	   #:define-concept
	   #:define-concrete-domain-attribute
	   #:define-datatype-property
	   #:define-disjoint-primitive-concept
	   #:define-distinct-individual
	   #:define-event-assertion
	   #:define-event-rule
	   #:define-individual
	   #:define-prefix
	   #:define-primitive-attribute
	   #:define-primitive-concept
	   #:define-primitive-role
	   #:define-rule
	   #:define-tbox
	   #:define-tbox-1
	   #:defprimattribute
	   #:defprimconcept
	   #:defprimrole
	   #:delete-abox
	   #:delete-all-aboxes
	   #:delete-all-tboxes
	   #:delete-tbox
	   #:describe-abox
	   #:describe-concept
	   #:describe-individual
	   #:describe-individual1
	   #:describe-role
	   #:describe-tbox
	   #:different-from
	   #:dig-read-document
	   #:dig-read-file
	   #:direct-predecessors
	   #:disable-abduction
	   #:disable-alisp-compatibility-mode
	   #:disjoint
	   #:display-graph
	   #:divisible
	   #:domain
	   #:enable-abduction
	   #:enable-alisp-compatibility-mode
	   #:enable-optimized-query-processing
	   #:ensure
	   #:ensure-abox-name
	   #:ensure-abox-signature
	   #:ensure-cd-attribute
	   #:ensure-precompletion-materialization
	   #:ensure-small-tboxes
	   #:ensure-subsumption-based-query-answering
	   #:ensure-tbox-name
	   #:ensure-tbox-signature
	   #:equal
	   #:equivalent
	   #:exactly
	   :export
	   #:expt
	   #:false-value-reader
	   #:feature-p
	   #:feature?
	   #:find-abox
	   #:find-reasoner
	   #:find-tbox
	   #:forget
	   #:forget-abox
	   #:forget-concept-assertion
	   #:forget-concept-axiom
	   #:forget-constrained-assertion
	   #:forget-constraint
	   #:forget-disjointness-axiom
	   #:forget-disjointness-axiom-statement
	   #:forget-individual
	   #:forget-role-assertion
	   #:forget-role-axioms
	   #:forget-statement
	   #:forget-tbox
	   #:functional
	   #:get-abox-language
	   #:get-abox-signature
	   #:get-abox-version
	   #:get-build-version
	   #:get-concept-definition
	   #:get-concept-definition-1
	   #:get-concept-negated-definition
	   #:get-concept-negated-definition-1
	   #:get-concept-pmodel
	   #:get-individual-pmodel
	   #:get-kb-signature
	   #:get-meta-constraint
	   #:get-namespace-prefix
	   #:get-namespace-prefixes
	   #:get-product-name
	   #:get-product-version
	   #:get-racer-version
	   #:get-role-datatype
	   #:get-server-timeout
	   #:get-tbox-language
	   #:get-tbox-signature
	   #:get-tbox-version
	   #:|http://www.w3.org/2001/XMLSchema#boolean|
	   #:|http://www.w3.org/2001/XMLSchema#byte|
	   #:|http://www.w3.org/2001/XMLSchema#decimal|
	   #:|http://www.w3.org/2001/XMLSchema#double|
	   #:|http://www.w3.org/2001/XMLSchema#float|
	   #:|http://www.w3.org/2001/XMLSchema#fractionDigits|
	   #:|http://www.w3.org/2001/XMLSchema#int|
	   #:|http://www.w3.org/2001/XMLSchema#integer|
	   #:|http://www.w3.org/2001/XMLSchema#length|
	   #:|http://www.w3.org/2001/XMLSchema#long|
	   #:|http://www.w3.org/2001/XMLSchema#maxExclusive|
	   #:|http://www.w3.org/2001/XMLSchema#maxInclusive|
	   #:|http://www.w3.org/2001/XMLSchema#maxLength|
	   #:|http://www.w3.org/2001/XMLSchema#min Exclusive|
	   #:|http://www.w3.org/2001/XMLSchema#minInclusive|
	   #:|http://www.w3.org/2001/XMLSchema#minLength|
	   #:|http://www.w3.org/2001/XMLSchema#negativeInteger|
	   #:|http://www.w3.org/2001/XMLSchema#nonNegativeInteger|
	   #:|http://www.w3.org/2001/XMLSchema#nonPositiveInteger|
	   #:|http://www.w3.org/2001/XMLSchema#pattern|
	   #:|http://www.w3.org/2001/XMLSchema#short|
	   #:|http://www.w3.org/2001/XMLSchema#string|
	   #:|http://www.w3.org/2001/XMLSchema#totalDigits|
	   #:|http://www.w3.org/2001/XMLSchema#unsignedByte|
	   #:|http://www.w3.org/2001/XMLSchema#unsignedInt|
	   #:|http://www.w3.org/2001/XMLSchema#unsignedLong|
	   #:|http://www.w3.org/2001/XMLSchema#unsignedShort|
	   #:implies
	   #:implies-role
	   #:import-kb
	   #:in-abox
	   #:in-abox-internal
	   #:in-knowledge-base
	   #:in-tbox
	   #:in-tbox-internal
	   #:include-kb
	   #:index-all-triples
	   #:individual-antonyms
	   #:individual-attribute-fillers
	   #:individual-direct-types
	   #:individual-filled-roles
	   #:individual-fillers
	   #:individual-instance-p
	   #:individual-instance?
	   #:individual-p
	   #:individual-synonyms
	   #:individual-told-attribute-value
	   #:individual-told-datatype-fillers
	   #:individual-types
	   #:individual?
	   #:individuals-equal-p
	   #:individuals-equal?
	   #:individuals-not-equal-p
	   #:individuals-not-equal?
	   #:individuals-related-p
	   #:individuals-related?
	   #:init-abox
	   #:init-publications
	   #:init-publications-1
	   #:init-subscriptions
	   #:init-subscriptions-1
	   #:init-tbox
	   #:instance
	   #:instantiators
	   #:integer
	   #:internal-individuals-related-p
	   #:internal-retrieve-direct-predecessors
	   #:internal-retrieve-individual-filled-roles
	   #:internal-retrieve-individual-fillers
	   #:internal-retrieve-related-individuals
	   #:inv
	   #:inverse
	   #:inverse-feature-p
	   #:inverse-feature?
	   #:inverse-of-role
	   #:irreflexive
	   #:irreflexive-p
	   #:irreflexive?
	   #:kb-ontologies
	   #:last-answer
	   #:last-output-stream-string
	   #:lcs
	   #:lcs-unfold
	   #:logging-off
	   #:logging-on
	   #:loop-over-aboxes
	   #:loop-over-tboxes
	   #:materialize-inferences
	   #:max
	   #:min
	   #:mirror
	   #:most-specific-instantiators
	   #:msc-k
	   #:no
	   #:not
	   #:not-divisible
	   #:one-of
	   #:open-triple-store
	   #:or
	   #:owl-read-document
	   #:owl-read-file
	   #:owllink-read-document
	   #:owllink-read-file
	   #:parse-expression
	   #:pracer-answer-query
	   #:prepare-abox
	   #:prepare-racer-engine
	   #:pretrieve
	   #:print-abox-individuals
	   #:print-cgb-info
	   #:print-cl-http-info
	   #:print-debug-info
	   #:print-racer-info
	   #:print-tbox-tree
	   #:print-wilbur-info
	   #:publish
	   #:publish-1
	   #:publish-file
	   #:racer-answer-query-2
	   #:racer-answer-query-with-explanation
	   #:racer-internal%has-boolean-value
	   #:racer-internal%has-integer-value
	   #:racer-internal%has-real-value
	   #:racer-internal%has-string-value
	   #:racer-read-document
	   #:racer-read-file
	   #:range
	   #:rdfs-read-tbox-file
	   #:real
	   #:realize-abox
	   #:recognize-events
	   #:reflexive
	   #:reflexive-p
	   #:reflexive?
	   #:related
	   #:related-individuals
	   #:remove-prefix
	   #:restore-abox-image
	   #:restore-aboxes-image
	   #:restore-kb-image
	   #:restore-kbs-image
	   #:restore-tbox-image
	   #:restore-tboxes-image
	   #:retrieve-2
	   #:retrieve-concept-instances
	   #:retrieve-direct-predecessors
	   #:retrieve-individual-annotation-property-fillers
	   #:retrieve-individual-antonyms
	   #:retrieve-individual-attribute-fillers
	   #:retrieve-individual-filled-roles
	   #:retrieve-individual-fillers
	   #:retrieve-individual-synonyms
	   #:retrieve-individual-told-attribute-value
	   #:retrieve-individual-told-datatype-fillers
	   #:retrieve-related-individuals
	   #:retrieve-with-explanation
	   #:return-policy
	   #:rewrite-concept
	   #:role-ancestors
	   #:role-antonyms
	   #:role-children
	   #:role-descendants
	   #:role-disjoint-p
	   #:role-disjoint?
	   #:role-domain
	   #:role-equivalent-p
	   #:role-equivalent?
	   #:role-has-domain
	   #:role-has-parent
	   #:role-has-range
	   #:role-inverse
	   #:role-is-asymmetric
	   #:role-is-functional
	   #:role-is-irreflexive
	   #:role-is-reflexive
	   #:role-is-symmetric
	   #:role-is-transitive
	   #:role-is-used-as-annotation-property
	   #:role-is-used-as-datatype-property
	   #:role-offspring
	   #:role-p
	   #:role-parents
	   #:role-range
	   #:role-satisfiable-p
	   #:role-satisfiable?
	   #:role-subsumes-p
	   #:role-subsumes?
	   #:role-synonyms
	   #:role-used-as-annotation-property-p
	   #:role-used-as-datatype-property-p
	   #:role?
	   #:roles-disjoint
	   #:roles-disjoint-1
	   #:roles-equivalent
	   #:roles-equivalent-1
	   #:same-as
	   #:same-individual-as
	   #:save-abox
	   #:save-kb
	   #:save-ontology-to-triple-store
	   #:save-tbox
	   #:self-reference
	   #:server-case
	   #:set-associated-tbox
	   #:set-attribute-filler
	   #:set-current-abox
	   #:set-current-tbox
	   #:set-find-abox
	   #:set-find-tbox
	   #:set-product-name
	   #:set-rewrite-defined-concepts
	   #:set-server-timeout
	   #:set-unique-name-assumption
	   #:signature
	   #:simple-output
	   #:some
	   #:sparql-answer-query
	   #:sparql-retrieve
	   #:state
	   #:store-abox-image
	   #:store-aboxes-image
	   #:store-kb-image
	   #:store-kbs-image
	   #:store-tbox-image
	   #:store-tboxes-image
	   #:string
	   #:string<>
	   #:string=
	   #:subscribe
	   #:subscribe-1
	   #:swrl-forward-chaining
	   #:symmetric
	   #:symmetric-p
	   #:symmetric?
	   #:taxonomy
	   #:tbox-classified-p
	   #:tbox-classified?
	   #:tbox-coherent-p
	   #:tbox-coherent?
	   #:tbox-cyclic-p
	   #:tbox-cyclic?
	   #:tbox-namespaces
	   #:tbox-prepared-p
	   #:tbox-prepared?
	   #:temp-directory
	   #:test-assert
	   #:test-verify-with-abox-individuals-list
	   #:test-verify-with-concept-tree-list
	   #:test-with-timeout
	   #:time
	   #:timed-out-test-assert
	   #:timed-out-test-verify-with-abox-individuals-list
	   #:timenet-answer-query
	   #:timenet-retrieve
	   #:told-value
	   #:top
	   #:transitive
	   #:transitive-p
	   #:transitive?
	   #:transmit-file
	   #:triple-store-graphs
	   #:triple-store-open-p
	   #:triple-store-read-file
	   #:true-value-reader
	   #:unequal
	   #:unpublish
	   #:unpublish-1
	   #:unrelated
	   #:unsubscribe
	   #:unsubscribe-1
	   #:use-triple-store
	   #:validate-false
	   #:validate-set
	   #:validate-true
	   #:verify-with-abox-individuals-list
	   #:verify-with-concept-tree
	   #:verify-with-concept-tree-list
	   #:with-kb-statistics
	   #:with-racer-critical-section
	   #:with-racer-statistics
	   #:with-reasoner
	   #:with-sat-statistics
	   #:with-server-connection
	   #:with-server-timeout
	   #:with-unique-name-assumption
	   #:with-verbose-statistics
	   #:without-signature-checks
	   #:without-timeout
	   #:without-unique-name-assumption
	   #:xml-read-tbox-file

	   ;;
	   ;;
	   ;;
	   
	   #:*default-racer-host* 
	   #:*default-racer-tcp-port*
	   #:*external-format* 
	   #:with-server-connection
	   #:open-server-connection
	   #:close-server-connection
	   #:transform-s-expr
	   #:enable-lracer-read-macros))

(eval-when (:load-toplevel :execute)
  (defun use-racer-in-cl-user ()
    (dolist (package '(racer nrql-symbols))
      (loop for sym being the external-symbols of (find-package package) do
	    (let ((cl-user-sym (find-symbol (symbol-name sym) 'cl-user)))
	      (when cl-user-sym
		(unintern cl-user-sym 'cl-user)))
	    (import sym 'cl-user)))))

(eval-when (:load-toplevel :execute)
  (use-racer-in-cl-user))

(defpackage racer-user
  (:use common-lisp racer nrql-symbols))

;;;
;;;
;;; 

#|

(defun get-racer-syms ()
  (let ((package 'racer))
    (mapc #'(lambda (x) 
	      (if (search "http://" (symbol-name x))
		  (princ (format nil "#:|~A|" x)) 
		(princ (format nil "#:~A" x)))
	      (terpri))
	  (sort 
	   (loop for sym being the external-symbols of (find-package package) 
	       unless (progn (multiple-value-bind (sym foundp)
				 (find-symbol (symbol-name sym) :nrql-symbols)
			       (member foundp '(:external :inherited))))
	       collect sym)
	   #'string<
	   :key #'symbol-name))))

(get-racer-syms)

|# 
